#include "Arduino.h"
#include "DebugOverSoftSerial.h"
#include <SoftwareSerial.h>


SoftwareSerial DebugOverSoftSerial::softSerial(10, 11); // RX, TX

#define NOT_INITIALIZED 0
#define INITIALIZED 1

char DebugOverSoftSerial::state = NOT_INITIALIZED;

// Initialize the constructors
DebugOverSoftSerial::DebugOverSoftSerial()
{
}
 
void DebugOverSoftSerial::init()
{
    if (state != INITIALIZED)
    {
        softSerial.begin(9600);
        state = INITIALIZED ;
    }	 	 
}

//PUBLIC METHODS
void DebugOverSoftSerial::print(const char* message)
{
	init();
	softSerial.print(message);
}

void DebugOverSoftSerial::println(const char* message)
{
	init();
	softSerial.println(message);
}

void DebugOverSoftSerial::print(const char character)
{
	init();
	softSerial.print(character);
}

void DebugOverSoftSerial::println(const char character)
{
	init();
	softSerial.println(character);
}

void DebugOverSoftSerial::print_P(const char* message) 
{
  init();
  for(int i = 0; ; i++)
  {
    char c = pgm_read_byte_near(message + i);
	if (c == 0)
	{
      break;
	}
	softSerial.print(c);
  }
}

void DebugOverSoftSerial::println_P(const char* message) 
{
  init();
  print_P(message);
  softSerial.print('\r');
  softSerial.print('\n');
}